#!/usr/bin/perl
#
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;

#require "/work1/ssa/perl/MY/my.pl";
require "/home/sanchez/sda2/code/R3D/my.pl";


if ($#ARGV<3) {
    print "USE: FIT3D_output_rss_seg2cube.pl FIT3D_output.RSS.fits N.OUT SEGMENTATION.fits OUTPUT.CUBE.FITS\n";
    exit;
}

$infile=$ARGV[0];
$nout=$ARGV[1];
$segfile=$ARGV[2];
$outfile=$ARGV[3];
$pt=$outfile;
$pt =~ s/fits/pt.txt/;

$a_in_rss=rfits($infile);
$h=$a_in_rss->gethdr;

($nz,$Nx,$Ny)=$a_in_rss->dims;
$crval=$a_in_rss->hdr->{CRVAL1};
$cdelt=$a_in_rss->hdr->{CDELT1};
$crpix=$a_in_rss->hdr->{CRPIX1};


$a_in=$a_in_rss->slice(":,:,($nout)");

$s_in=rfits($segfile);
($nx,$ny)=$s_in->dims;


$out_cube=zeroes(float,$nx,$ny,$nz);
$out_cube->hdr->{CRVAL3}=$crval;
$out_cube->hdr->{CDELT3}=$cdelt;
$out_cube->hdr->{CRPIX3}=$crpix;


for ($i=0;$i<$nx;$i++) {
    for ($j=0;$j<$ny;$j++) {
	$is=$s_in->at($i,$j);
	if ($is>0) {
	    $is_out=$is-1;
	    my $t=$out_cube->slice("($i),($j),:");
	    $s=$a_in->slice(":,($is_out)");
#	    print "($nz,$Nx,$Ny) $i/$nx,$j/$ny $is_out\n";
	    $t .= $s;
	}
    }
}

$out_cube->wfits($outfile);

print "$outfile created\n";


exit;
